##
##  fsharp.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_fsharp 1.9.6.16

#   package information
Name:         fsharp
Summary:      F# Programming Language
URL:          http://msdn.microsoft.com/fsharp/
Vendor:       Microsoft Corporation
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      Open Source
Version:      %{V_fsharp}
Release:      20090620

#   list of sources
Source0:      http://download.microsoft.com/download/F/7/4/F74A3170-261C-4E8F-B1A8-2E352C61A89B/fsharp.zip

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, infozip
PreReq:       OpenPKG, openpkg >= 20160101, mono

%description
    F# is a succinct, type-inferred, expressive, efficient functional
    and object-oriented language for the .NET platform. It is inspired
    by OCaml and ML.

%track
    prog fsharp = {
        disabled
        comment   = "cannot be easily tracked currently"
        version   = %{version}
        url       = http://research.microsoft.com/en-us/um/cambridge/projects/fsharp/release.aspx
        regex     = fsharp-(__VER__)\.zip
    }

%prep
    %setup -q -T -c -n FSharp-%{V_fsharp}
    cd ..
    unzip -q -x %{SOURCE0}

%build

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/fsharp
    rm -rf bin/gac
    %{l_shtool} install -c -m 644 \
        bin/* $RPM_BUILD_ROOT%{l_prefix}/libexec/fsharp/
    for prog in fsc fsi fslex fsyacc; do
        ( echo "#!/bin/sh"
          echo "exec %{l_prefix}/bin/mono %{l_prefix}/libexec/fsharp/$prog.exe \${1+\"\$@\"}"
        ) >$prog.sh
        %{l_shtool} install -c -m 755 \
            $prog.sh $RPM_BUILD_ROOT%{l_prefix}/bin/$prog
    done
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

%post
    $RPM_INSTALL_PREFIX/bin/gacutil -i $RPM_INSTALL_PREFIX/libexec/fsharp/FSharp.Core.dll
    $RPM_INSTALL_PREFIX/bin/gacutil -i $RPM_INSTALL_PREFIX/libexec/fsharp/FSharp.Compiler.dll
    $RPM_INSTALL_PREFIX/bin/gacutil -i $RPM_INSTALL_PREFIX/libexec/fsharp/FSharp.PowerPack.dll

%preun
    $RPM_INSTALL_PREFIX/bin/gacutil -u FSharp.Compiler  >/dev/null 2>&1 || true
    $RPM_INSTALL_PREFIX/bin/gacutil -u FSharp.Core      >/dev/null 2>&1 || true
    $RPM_INSTALL_PREFIX/bin/gacutil -u FSharp.PowerPack >/dev/null 2>&1 || true

